//file udpinst.c
//instruments controlled by udp datagrams
//assume each instrument has an ethernet mac address in the local host table
//Oct 12 2000 Bob G initial edit from udptalk
//Oct 19 2000 Bob G connect on hisaddr, not my addr

#include <windows.h>     
#include <stdio.h>     
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <winsock.h>
#include <dos.h>

#define ETHPKTLEN  1500

SOCKET sockout,sockin;
WORD wVersionRequested;
WSADATA wsaData;
struct sockaddr myaddr;
struct sockaddr_in myinaddr,hisinaddr;
struct hostent *he;
char inetbuf[ETHPKTLEN]; //from net
char onetbuf[ETHPKTLEN]; //to net
char othermachinename[20];
char myname[20],hisname[20];
char c;
char errstr[250];
int fromlen;
int desport;
int tmpport;
int exitflg;
int res;
int ndx;
int verbose=0;
int flags=0;
int display=1;
int alt,altinc;
unsigned char fa1,fa2,fa3,fa4;
unsigned char ma1,ma2,ma3,ma4;

//-------------------
void spin(void){
//spin the spinner
static char spindat[4]={'/','-','\\','|'};
static int spindex=0;

  printf("%c\r",spindat[spindex++]);
  if(spindex==4) spindex=0;
  fflush(stdout);
}

//--------------------
byte getbyte(void){
//return byte from buf
  return ((byte*)inetbuf)[ndx++];
}

//------------------
unsigned int getword(void){
//return big endian word from buf
  return(unsigned int)((getbyte() <<8)+getbyte());
}

unsigned int getleword(void){
//return little endian word from buf
  return(unsigned int)(getbyte()+(getbyte() << 8));
}

//--------------------------
unsigned int getlong(void){
//return big endian long from buf
  return(unsigned int)((getword() <<16)+getword());
}

unsigned int getlelong(void){
//return little endian long from buf
  return(unsigned int)(getleword()+(getleword() << 16));
}

//------------------------
void uninit(void){
//shut down mm wave in and out

  closesocket(sockout);
  closesocket(sockin);
  WSACleanup();
}

//------------------------------------
void initsockets(void){
//create udp socket using winsock
unsigned char *p;

  wVersionRequested = MAKEWORD(2,0);
  res=WSAStartup(wVersionRequested, &wsaData);
  if(res){ // Tell the user that we couldn't find a usable WinSock DLL
	  printf("startup err!\n");
	  exit(-1);
  }
//  printf("max udp datagram is %d\n",wsaData.iMaxUdpDg);
	
  /* Confirm that the WinSock DLL supports 2.0.*/
  /* Note that if the DLL supports versions greater	 */
  /* than 2.0 in addition to 2.0, it will still return */
  /* 2.0 in wVersion since that is the version we 	 */
  /* requested.										 */
	
  if(LOBYTE(wsaData.wVersion) !=2 || HIBYTE( wsaData.wVersion) !=0) {
	  WSACleanup();
	  printf("version err!\n");
	  exit(-1); 
  }
  printf("winsock version %x\n",wsaData.wVersion);
 
  sockout=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
  if(sockout==INVALID_SOCKET){
	  printf("couldn't create sockout. getlasterror was %d\n",WSAGetLastError());
	  exit(1);
  }

  sockin=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
  if(sockin==INVALID_SOCKET){
	  printf("couldn't create sockin. getlasterror was %d\n",WSAGetLastError());
	  exit(1);
  }

#if 0
   toaddr.sin_family =AF_INET;      //toaddr is where I'm going to send these things
  toaddr.sin_port =htons(desport); //port 3001 from cmd line
//  addr.S_un.S_addr=INADDR_BROADCAST;
//  toaddr.sin_addr =addr;		   //dst ip addr broadcast

  res=setsockopt(sockout,SOL_SOCKET,SO_BROADCAST,(const char *)&optval,sizeof(optval));
  if(res){
    printf("setsockopt err %d\n",WSAGetLastError());
  }
  res=setsockopt(sockin,SOL_SOCKET,SO_REUSEADDR,(const char *)&optval,sizeof(optval));
  if(res){
    printf("reuseaddr err %d\n",WSAGetLastError());
  }

//  fromlen=sizeof(struct sockaddr);
//  res=getsockname(sockout,(struct sockaddr *)&myaddr,&fromlen);
//  printf("myaddr.sa_data after getsockname: %d %d  %d %d %d %d  %d %d %d %d %d %d %d %d\n",
//    myaddr.sa_data[0],myaddr.sa_data[1],myaddr.sa_data[2],myaddr.sa_data[3],
//    myaddr.sa_data[4],myaddr.sa_data[5],myaddr.sa_data[6],myaddr.sa_data[7],
//    myaddr.sa_data[8],myaddr.sa_data[9],myaddr.sa_data[10],myaddr.sa_data[11],
//    myaddr.sa_data[12],myaddr.sa_data[13]);
//  c=getch();
#endif

  unsigned long nonblockingmode=1;
  res=ioctlsocket(sockin,FIONBIO,&nonblockingmode);
  if(res==SOCKET_ERROR) {
    printf("err %d from ioctlsocket\n",WSAGetLastError());
  	exit(1);
  }

  res=gethostname(myname,sizeof(myname));
  if(res==SOCKET_ERROR) printf("gethostname lasterr %d",WSAGetLastError());
  printf("my name is %s\n",myname);

  he=gethostbyname(myname);
  if(he==NULL) printf("gethostbyname lasterr %d",WSAGetLastError());
  p= (unsigned char *)*he->h_addr_list;
  printf("my ip add is: %d.%d.%d.%d\n",
		(unsigned char)p[0],(unsigned char)p[1],(unsigned char)p[2],(unsigned char)p[3]);

//struct sockaddr_in {
//        short   sin_family;
//        u_short sin_port;
//        struct  in_addr sin_addr;
//        char    sin_zero[8];
//};
  myinaddr.sin_family =AF_INET;
  myinaddr.sin_port=htons(desport);     //port 3001 hi byte
  memcpy((void *)&myinaddr.sin_addr,p,4);

  res=bind(sockin,(struct sockaddr *)&myinaddr,sizeof(myinaddr));
  if(res) {
    if(res==SOCKET_ERROR) printf("bind error %d\n",WSAGetLastError());
  }

  he=gethostbyname(othermachinename); //from cmd line
  if(he==NULL) printf("gethostbyname lasterr %d",WSAGetLastError());
  p= (unsigned char *)*he->h_addr_list;
  printf("his ip add is: %d.%d.%d.%d\n",
		(unsigned char)p[0],(unsigned char)p[1],(unsigned char)p[2],(unsigned char)p[3]);

//  myaddr.sa_family =AF_INET;
//  myaddr.sa_data[0]=desport >>8;     //port 3001 hi byte
//  myaddr.sa_data[1]=desport & 0xff;	 //port 3001 lo byte
//  myaddr.sa_data[2]=p[0];
//  myaddr.sa_data[3]=p[1];
//  myaddr.sa_data[4]=p[2];
//  myaddr.sa_data[5]=p[3];

//  printf("myaddr.sa_data after bind: %d %d  %d %d %d %d  %d %d %d %d %d %d %d %d\n",
//    myaddr.sa_data[0],myaddr.sa_data[1],myaddr.sa_data[2],myaddr.sa_data[3],
//    myaddr.sa_data[4],myaddr.sa_data[5],myaddr.sa_data[6],myaddr.sa_data[7],
//    myaddr.sa_data[8],myaddr.sa_data[9],myaddr.sa_data[10],myaddr.sa_data[11],
//    myaddr.sa_data[12],myaddr.sa_data[13]);

  hisinaddr.sin_family =AF_INET;
  hisinaddr.sin_port=htons(desport);     //port 3001 hi byte
  memcpy((void *)&hisinaddr.sin_addr,p,4);

	res=connect(sockout,(struct sockaddr *)&hisinaddr,sizeof(hisinaddr));
  if(res) {
    if(res==SOCKET_ERROR) printf("connect error %d    result was %d\n",
			WSAGetLastError(),res);
  }
  printf("hisinaddr after connect: family: %d  port: %d  addr: %s\n",
		hisinaddr.sin_family,ntohs(hisinaddr.sin_port),inet_ntoa((struct in_addr)hisinaddr.sin_addr));
}

//-----------------------
void sendpkt(void){
//send packets in udp datagrams
char c;
int ondx;

  printf("sending alt     q to quit\n");
  alt=1000;
	altinc=10;
	c=0;
  while(c != 'q'){
		if(kbhit()){
			c=getch();
    }
		alt+=altinc;
    if(alt > 50000) altinc= -altinc;
    if(alt < -1000) altinc= -altinc;
    ondx=0;
    onetbuf[ondx++]=(alt & 0xff000000) >> 24;
    onetbuf[ondx++]=(alt & 0x00ff0000) >> 16;
    onetbuf[ondx++]=(alt & 0x0000ff00) >> 8;
    onetbuf[ondx++]=(alt & 0x000000ff);
    res=send(sockout,(LPSTR)onetbuf,ondx,flags);
//    res=sendto(sock,(LPSTR)onetbuf,ndx,flags,(SOCKADDR *)&myaddr,sizeof(myaddr));
    if(res == SOCKET_ERROR){
      printf("send err %d\n",WSAGetLastError());
		}
		printf("%5d \r",alt);
		fflush(stdout);
		Sleep(30);
	}
}

//-----------------------
void recvpkt(void){
//recv udp datagram packets
char c;
int reclen;

  printf("waiting....\n");
  while(!exitflg){
    if(kbhit()){
  	  c=getch();
	    switch(c){
	      case 'v': verbose= !verbose; break;
	      case 'q': exitflg=1; break;
			} //switch
		}  //kbhit

    //try to recv a pkt into inetbuf. returns ok if pkt, error if no pkt
	  reclen=recv(sockin,(LPSTR)&inetbuf[0],sizeof(inetbuf),flags);
	  if(reclen==SOCKET_ERROR){ //-1
	    res=WSAGetLastError();
	    if(res !=WSAEWOULDBLOCK){
	      printf("recv err %d\n",res);
			}
		}
    if(reclen != -1){ //valid length means good pkt recd
      //port in sa_data in non network order!!
//	    tmpport=ntohs(myaddr.sa_data[0]+myaddr.sa_data[1]*256); //where it was going
//      if(tmpport==desport){ //right port?
//	      if(verbose){
//	        printf("     rcvd %d bytes on port: %d\n", reclen,tmpport);
//				}
//      }
			ndx=0;
      alt=getlong();
      printf("  %4d\r",alt);
      fflush(stdout);
		} 
  }	//while
}

//---------------------------
void menu(void){
  printf("\nUDPinst cmds:\n");
  printf(" s send pkts\n");
  printf(" r recv pkts \n");
  printf(" v verbose\n");
  printf(" q quit\n");
}

//--------------------------------
int main(int argc, char *argv[]){
//udpinst main program
char c;
int exitflg;
  
  printf("UDPinst Oct 19 2000 Bob G\n");
  printf("Sends UDP datagrams on port 3001\n");
  if(argc != 2){
  	printf("usage:C>udpinst othermachinename\n");
  	printf("ex:   C>udpinst dave\n");
  	exit(-1);
	}
  strcpy(othermachinename,(char *)argv[1]);
  desport=3001;
  initsockets();    //open udp datagram socket
	exitflg=0;
  while(!exitflg){
    menu();
    printf("Enter command:");
  	fflush(stdout);
	  c=getch();
	  switch(c){
	    case 's': sendpkt();    break;
	    case 'r': recvpkt();    break;
	    case 'q': exitflg=1;  break;
	    default: menu();
		} //switch
  }	//while
  uninit();
  return(0);
}
//-----------------eof---------------------
